/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_NumericValueQualifier;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_NumericValueQualifier;



/**
 * This class represents NumericValueQualifier - CID42
 */
public class NumericValueQualifier_CID42  
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;
	
	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;
	
	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;
	
	/**
	 * Instantiates a new NumericValueQualifier_DCIT42 Template 
	 */
	public NumericValueQualifier_CID42()
	{
		
	}
	
	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumNumericValueQualifier Object of EnumCM_NumericValueQualifier represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_NumericValueQualifier enumNumericValueQualifier)
	{
		switch(enumNumericValueQualifier)
		{
		case CALCULATION_FAILURE:
			this.strCodeValue = EnumCV_NumericValueQualifier.CALCULATION_FAILURE_114008.getValue();
			break;
		case DIVIDE_BY_ZERO:
			this.strCodeValue = EnumCV_NumericValueQualifier.DIVIDE_BY_ZERO_114003.getValue();
			break;
		case MEASUREMENT_FAILURE:
			this.strCodeValue = EnumCV_NumericValueQualifier.MEASUREMENT_FAILURE_114006.getValue();
			break;
		case MEASUREMENT_NOT_ATTEMPTED:
			this.strCodeValue = EnumCV_NumericValueQualifier.MEASUREMENT_NOT_ATTEMPTED_114007.getValue();
			break;
		case NEGATIVE_INFINITY:
			this.strCodeValue = EnumCV_NumericValueQualifier.NEGATIVE_INFINITY_114001.getValue();
			break;
		case NOT_A_NUMBER:
			this.strCodeValue = EnumCV_NumericValueQualifier.NOT_A_NUMBER_114000.getValue();
			break;
		case OVERFLOW:
			this.strCodeValue = EnumCV_NumericValueQualifier.OVERFLOW_114005.getValue();
			break;
		case POSITIVE_INFINITY:
			this.strCodeValue = EnumCV_NumericValueQualifier.POSITIVE_INFINITY_114002.getValue();
			break;
		case UNDERFLOW:
			this.strCodeValue = EnumCV_NumericValueQualifier.UNDERFLOW_114004.getValue();
			break;
		case VALUE_INDETERMINATE:
			this.strCodeValue = EnumCV_NumericValueQualifier.VALUE_INDETERMINATE_114011.getValue();
			break;
		case VALUE_OUT_OF_RANGE:
			this.strCodeValue = EnumCV_NumericValueQualifier.VALUE_OUT_OF_RANGE_114009.getValue();
			break;
		case VALUE_UNKNOWN:
			this.strCodeValue = EnumCV_NumericValueQualifier.VALUE_UNKNOWN_114010.getValue();
			break;
		}
	}
	
	/**
	 * Sets the value for NumericValueQualifier
	 * @param enumNumericValueQualifier Object of EnumCM_NumericValueQualifier.
	 */
	public void setNumericValueQualifier(EnumCM_NumericValueQualifier enumNumericValueQualifier)
	{
		this.strCodeMeaning = enumNumericValueQualifier.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		setCodeValue(enumNumericValueQualifier);
	}
}
